//;*****************************************************
//;Company :   rakwireless
//;File Name : rak_send_data.c
//;Author :    Junhua
//;Create Data : 2014-01-12
//;Last Modified : 
//;Description : RAK415 WIFI UART  DRIVER
//;Version :    1.0.5
//;update url:  www.rakwireless.com
//;****************************************************
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Nano1X2Series.h"
#include "rak_config.h"
#include "rak_global.h"


/*=============================================================================*/
/**
 * @fn           int16 rak_send_data(void)
 * @brief        UART
 * @param[in]    socket_id,Send_Data,Send_DataLen
 * @param[out]   none
 * @return       errCode
 *               -1 = busy 
 *               0  = SUCCESS
 * @section description  
 * 
 */
 /*=============================================================================*/

int8_t rak_send_Data(uint8_t socket_id,uint8_t *send_Data,uint16_t send_DataLen)
{
	 int8	     retval=0;
	 char rak_sendCmd[30]="";
	 char sock[2]="";
	 char sendlen[5]="";
	 sock[0]=socket_id+0x30;
	 strcpy(rak_sendCmd,RAK_SEND_DATA_CMD);
	 strcat(rak_sendCmd,sock);
	 strcat(rak_sendCmd,RAK_COMMA);
	 sprintf(sendlen,"%d",send_DataLen);
	 strcat(rak_sendCmd,sendlen);
	 strcat(rak_sendCmd,RAK_COMMA);

	 retval=rak_UART_send((uint8_t*)rak_sendCmd,strlen(rak_sendCmd));
     retval=rak_UART_send(send_Data,send_DataLen);
	 retval=rak_UART_send(RAK_END,strlen(RAK_END));
	 return retval;
}
