/******************************************************************************
 * @file     main.c
 * @brief    Nano1x2 Semihost Sample code
 * @version  1.0.1
 * @date     24, October, 2013
 *
 * @note
 * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#include <stdio.h>
#include "Nano1X2Series.h"

void SYS_Init(void)
{
    /*---------------------------------------------------------------------------------------------------------*/
    /* Init System Clock                                                                                       */
    /*---------------------------------------------------------------------------------------------------------*/
    /* Unlock protected registers */
    SYS_UnlockReg();

    /* Enable Internal RC (12 MHz) */
    CLK->PWRCTL &= ~CLK_PWRCTL_HIRC_EN_Msk;
    CLK->PWRCTL |= (0x1 << CLK_PWRCTL_HIRC_EN_Pos);

    /* Waiting for 12MHz clock ready */
    while((CLK->CLKSTATUS & CLK_CLKSTATUS_HIRC_STB_Msk) != CLK_CLKSTATUS_HIRC_STB_Msk)

    /* Switch HCLK clock source to XTAL */
    CLK->CLKSEL0 &= ~CLK_CLKSEL0_HCLK_S_Msk;
    CLK->CLKSEL0 |= CLK_CLKSEL0_HCLK_S_HIRC;

    /* Enable IP clock */


    /* Select IP clock source */


    /* Update System Core Clock */
    /* User can use SystemCoreClockUpdate() to calculate PllClock, SystemCoreClock and CycylesPerUs automatically. */
    SystemCoreClockUpdate();

    /*---------------------------------------------------------------------------------------------------------*/
    /* Init I/O Multi-function                                                                                 */
    /*---------------------------------------------------------------------------------------------------------*/

    /* Lock protected registers */
    SYS_LockReg();

}

/*---------------------------------------------------------------------------------------------------------*/
/* Main Function                                                                                           */
/*---------------------------------------------------------------------------------------------------------*/

int32_t main()
{
    uint8_t c;

    SYS_Init();

    printf("\n Start SEMIHOST test: \n");

    while(1) {
        c = getchar();
        printf("%c\n",c);
    }

}





/*** (C) COPYRIGHT 2012 Nuvoton Technology Corp. ***/



