//
// Smpl_GPIO : GPIO to button inputs
//
// MCU : Nano102SC2AN
// EVB : NUWAROCKS v1.0

// GPIOs
// PB12 to KEY1
// PB13 to KEY2
// PB14 to KEY3

#include <stdio.h>
#include "Nano1X2Series.h"

void SYS_Init(void)
{
    /*---------------------------------------------------------------------------------------------------------*/
    /* Init System Clock                                                                                       */
    /*---------------------------------------------------------------------------------------------------------*/
    /* Unlock protected registers */
    SYS_UnlockReg();

    /* Enable Internal RC (12 MHz) */
    CLK_EnableXtalRC(CLK_PWRCTL_HIRC_EN_Msk);

    /* Waiting for 12MHz clock ready */
    CLK_WaitClockReady(CLK_CLKSTATUS_HIRC_STB_Msk);

    /* Set HCLK clock source */	
		//CLK_SetHCLK(CLK_CLKSEL0_HCLK_S_HIRC, CLK_HCLK_CLK_DIVIDER(1));
	  CLK_SetCoreClock(32000000);
	
    /* Select IP clock source */
	
	  /* Enable IP clock */

    /* Update System Core Clock */
    /* User can use SystemCoreClockUpdate() to calculate PllClock, SystemCoreClock and CycylesPerUs automatically. */
    SystemCoreClockUpdate();

    /*---------------------------------------------------------------------------------------------------------*/
    /* Init I/O Multi-function                                                                                 */
    /*---------------------------------------------------------------------------------------------------------*/	
		
    /* Lock protected registers */
    SYS_LockReg();
}

void Init_GPIO(void)
{
    GPIO_SetMode(PB, (BIT12 | BIT13 | BIT14), GPIO_PMD_INPUT);
	  GPIO_ENABLE_PULL_UP(PB, (BIT12 | BIT13 | BIT14));	 
    GPIO_SET_DEBOUNCE_TIME(GPIO_DBCLKSRC_HCLK, GPIO_DBCLKSEL_32768);
    GPIO_ENABLE_DEBOUNCE(PB, (BIT12 | BIT13 | BIT14));
}

/*---------------------------------------------------------------------------------------------------------*/
/* Main Function                                                                                           */
/*---------------------------------------------------------------------------------------------------------*/
int32_t main()
{	
    SYS_Init();	
	  Init_GPIO();

    while(1) {
			if (PB12==1) printf("KEY1=Off, ");
			else         printf("KEY1=On , ");
			if (PB13==1) printf("KEY2=Off, ");
			else         printf("KEY2=On , ");
			if (PB14==1) printf("KEY3=Off\n");
			else         printf("KEY3=On \n");			
    }
}
